# S2MLCore version 1.2.0
# S2MLOperator.py
# by Antoine Rauzy
# Copyrights (c) 2018-2021 AltaRica Association
#
# This file is part of S2MLCore.
# S2MLCore is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# S2MLCore is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with S2MLCore.  If not, see <http://www.gnu.org/licenses/>.

# Table of Contents
# -----------------
# 1) Imported modules
# 2) Operators

# 1) Imported modules
# -------------------

from S2MLDomains import *
from S2MLMetaModel import *

from S2MLType import *
from S2MLStochasticExpression import *

# 2) Operators
# ------------

class S2MLOperator(S2MLElement):
  def __init__(self, identifier, container):
    S2MLElement.__init__(self, S2MLType.OPERATOR, container)
    self.SetPathAndIdentifierAndInsertInContainerDictionary(identifier)
    self._arguments = []

  def GetNumberOfArguments(self):
    return len(self._arguments)
  def GetArgument(self, i):
    if i<0 or i>=len(self._arguments):
      return None
    return self._arguments[i]
  def GetArguments(self):
    return self._arguments
  def AppendArgument(self, argument):
    self._arguments.append(argument)
  def AppendArguments(self, arguments):
    self._arguments.extend(arguments)



