# S2MLCore version 1.2.0
# S2MLType.py
# by Antoine Rauzy
# Copyrights (c) 2018-2021 AltaRica Association
#
# This file is part of S2MLCore.
# S2MLCore is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# S2MLCore is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with S2MLCore.  If not, see <http://www.gnu.org/licenses/>.

# Table of Contents
# -----------------
# 1) Imported modules
# 2) S2MLType
# 3) S2ML Elements
# 4) Stochastic Expressions

# 1) Imported modules
# -------------------

# 2) Declaration
# --------------

class S2MLType:

# 3) S2ML Elements
# ----------------

  UNKNOWN = 0

  DOMAIN_DECLARATION = 201
  BLOCK = 203
  CLASS = 204
  CLONES = 206
  EMBEDS = 208
  EXTENDS = 209
  INSTANCE = 210
  FUNCTION = 211
  FUNCTION_CALL = 212
  OPERATOR = 213
  MODEL = 214
  PORT = 215
  ATTRIBUTE = 220
  PARAMETER = 221

  @staticmethod
  def IsDomainDeclaration(element):
    return element.GetType()==S2MLType.DOMAIN_DECLARATION

  @staticmethod
  def IsBlock(element):
    return element.GetType()==S2MLType.BLOCK

  @staticmethod
  def IsAttribute(element):
    return element.GetType()==S2MLType.ATTRIBUTE

  @staticmethod
  def IsParameter(element):
    return element.GetType()==S2MLType.PARAMETER

# 4) Stochastic expressions
# -------------------------

  REFERENCE_EXPRESSION = 301
  CONSTANT_EXPRESSION = 302
  OPERATOR_CALL_EXPRESSION = 303
  ADD_EXPRESSION = 311
  SUB_EXPRESSION = 312
  MUL_EXPRESSION = 313
  DIV_EXPRESSION = 314
  NEG_EXPRESSION = 315
  MIN_EXPRESSION = 316
  MAX_EXPRESSION = 317
  AND_EXPRESSION = 323
  OR_EXPRESSION  = 324
  NOT_EXPRESSION = 325
  EQ_EXPRESSION  = 331
  DF_EXPRESSION  = 332
  LT_EXPRESSION  = 333
  GT_EXPRESSION  = 334
  LEQ_EXPRESSION = 335
  GEQ_EXPRESSION = 336
  WITHIN_EXPRESSION = 337
  COUNT_EXPRESSION = 341
  IF_EXPRESSION = 342
  UNIFORM_DEVIATE_EXPRESSION = 351
  NORMAL_DEVIATE_EXPRESSION = 352
  LOGNORMAL_DEVIATE_EXPRESSION = 353
  TRIANGULAR_DEVIATE_EXPRESSION = 354
  EXPONENTIAL_DEVIATE_EXPRESSION = 355
  WEIBULL_DEVIATE_EXPRESSION = 356
  PIECEWISE_UNIFORM_DEVIATE_EXPRESSION = 357
  STEPWISE_DEVIATE_EXPRESSION = 358
  MISSION_TIME_EXPRESSION = 361
  EXP_EXPRESSION = 371
  LOG_EXPRESSION = 372
  POW_EXPRESSION = 373
  SQRT_EXPRESSION = 374
  FLOOR_EXPRESSION = 375
  CEIL_EXPRESSION = 375
  ABS_EXPRESSION = 376
  MOD_EXPRESSION = 377
  GAMMA_EXPRESSION = 378
  SIN_EXPRESSION = 381
  COS_EXPRESSION = 382
  TAN_EXPRESSION = 383
  ASIN_EXPRESSION = 384
  ACOS_EXPRESSION = 385
  ATAN_EXPRESSION = 386
  CONSTANT_DISTRIBUTION_EXPRESSION = 391
  EXPONENTIAL_DISTRIBUTION_EXPRESSION = 392
  GLM_DISTRIBUTION_EXPRESSION = 393
  WEIBULL_DISTRIBUTION_EXPRESSION = 394
  DIRAC_DISTRIBUTION_EXPRESSION = 395
  PIECEWISE_UNIFORM_DISTRIBUTION_EXPRESSION = 397
  STEPWISE_DISTRIBUTION_EXPRESSION = 398

